/*
	code file for PROforma

	routine to release a Gstate (PFRemoveGstate)

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 24 July 1993
	12.12.1995 PFGstateRemove now also works when gstate==NULL
	03.06.1996 CMTlist now also released
	04.06.1996 and freesubwins too
*/

#include "mem.h"

#include "gstate.h"
#include "list.h"

Error PFGstateRemove(Gstate gstate)
{
	fontrec *n;

	if (!gstate) return ERR_OK;

	gstate->flag[0]='*';	  /* make sure we refuse this one later */

	gstate->printer->CleanUp(gstate);
	if (gstate->BitmapAllocated)
		MEMRelease(gstate->rasterbase);
	MEMRelease(gstate->rasterpattern);
	MEMRelease(gstate->raster);
	MEMRelease(gstate->CacheForce);
	MEMUserZap(gstate->freesegments);
	list_release(gstate->subwindows);
	list_release(gstate->freesubwins);
	list_release(gstate->CTMlist);
	while(gstate->fontlist)
		PFFontUnLoad(gstate, gstate->fontlist->FullName);
	return MEMRelease(gstate);
}
